	//-----------------------------
	// quit confirmation window
	//-----------------------------
	quitConfirm = fl_bgn_form(FL_UP_BOX,  320, 120);

	fl_set_object_lstyle(fl_add_box(FL_NO_BOX, 160, 40, 0, 0, "Do you really want to quit?"), FL_BOLD_STYLE);
	yes = fl_add_button(FL_NORMAL_BUTTON,  40,  70,  80,  30, "Yes");
	fl_set_object_lstyle(yes, FL_BOLD_STYLE);
	no = fl_add_button(FL_NORMAL_BUTTON,  200,  70,  80,  30, "No");
	fl_set_object_lstyle(no, FL_BOLD_STYLE);

	fl_end_form();


	//-----------------------------
	// instruction history form
	//-----------------------------
	f_history_folder = fl_bgn_form(FL_FLAT_BOX, 510, 125);

	i_list = fl_add_browser(FL_HOLD_BROWSER,      5, 5, 505, 120, NULL);
	fl_set_object_lstyle(i_list, FL_FIXED_STYLE);

	fl_end_form();



	//-----------------------------
	// structures folder form
	//-----------------------------
	f_structures_folder = fl_bgn_form(FL_FLAT_BOX, 510, 125);

	st_list = fl_add_browser(FL_HOLD_BROWSER,      5, 5, 505, 115, NULL);
	fl_set_object_lstyle(st_list, FL_FIXED_STYLE);
	fl_set_browser_dblclick_callback(st_list, show_structure, 0);

	fl_end_form();



	//-----------------------------
	// breakpoint folder form
	//-----------------------------
	f_breakpoints_folder = fl_bgn_form(FL_FLAT_BOX, 510, 125);

	b_list = fl_add_browser(FL_HOLD_BROWSER,             5,   5, 180, 115, NULL);

	fl_set_object_lstyle(b_list, FL_FIXED_STYLE);

	add_button = fl_add_button(FL_NORMAL_BUTTON,       195,   5,  50,  25, "Add");
	remove_button = fl_add_button(FL_NORMAL_BUTTON,    260,   5,  50,  25, "Remove");
	clearall_button = fl_add_button(FL_NORMAL_BUTTON,  195,  35, 115,  25, "Clear All");
	fl_set_object_lstyle(add_button, FL_BOLD_STYLE);
	fl_set_object_lstyle(remove_button, FL_BOLD_STYLE);
	fl_set_object_lstyle(clearall_button, FL_BOLD_STYLE);
	fl_set_object_callback(add_button, add_breakpoint, 0);
	fl_set_object_callback(remove_button, remove_breakpoint, 0);
	fl_set_object_callback(clearall_button, clearall_breakpoints, 0);

	physical_check = fl_add_button(FL_RADIO_BUTTON,    222,  70,  20,  20, "P");
	linear_check = fl_add_button(FL_RADIO_BUTTON,      242,  70,  20,  20, "L");
	virtual_check = fl_add_button(FL_RADIO_BUTTON,     262,  70,  20,  20, "V");
	fl_set_button(virtual_check, 1);
	bp_type=BREAKPOINT_VIRTUAL;
	fl_set_object_lstyle(physical_check, FL_BOLD_STYLE);
	fl_set_object_lstyle(linear_check, FL_BOLD_STYLE);
	fl_set_object_lstyle(virtual_check, FL_BOLD_STYLE);
	fl_set_object_callback(physical_check, set_breakpoint_type, 0);
	fl_set_object_callback(linear_check, set_breakpoint_type, 0);
	fl_set_object_callback(virtual_check, set_breakpoint_type, 0);
	fl_add_text(FL_NORMAL_TEXT,                         315,  69, 200,  25, "Physical, Linear, or Virtual");

	b_address_text = fl_add_input(FL_NORMAL_INPUT,      195,  95, 115,  25, NULL);
	fl_set_input_maxchars(b_address_text, 17);
	fl_set_object_lstyle(b_address_text, FL_BOLD_STYLE);
	fl_set_input_return(b_address_text, FL_RETURN_END);
	fl_set_object_callback(b_address_text, add_breakpoint, 0);
	fl_add_text(FL_NORMAL_TEXT,                         315,  98, 200,  25, "Press ENTER or click ADD");

	fl_end_form();



	//-----------------------------
	// memory dump folder form
	//-----------------------------
	f_memory_folder = fl_bgn_form(FL_FLAT_BOX, 510, 125);

	fl_add_text(FL_NORMAL_TEXT,                             5,  5,  70, 25, "Address");
	m_address_text = fl_add_input(FL_NORMAL_INPUT,         60,  5, 115, 25, NULL);
	fl_set_input_maxchars(m_address_text, 17);
	fl_set_object_lstyle(m_address_text, FL_BOLD_STYLE);
	fl_set_input_return(m_address_text, FL_RETURN_END);
	fl_add_text(FL_NORMAL_TEXT,                         190,  8, 200,  25, "Press TAB to goto Units field");

	fl_bgn_group();
	m_linear = fl_add_button(FL_RADIO_BUTTON,     400,  5,  45,  20, "Linear");
	m_physical = fl_add_button(FL_RADIO_BUTTON,     445,  5,  55,  20, "Physical");
	fl_set_button(m_linear, 1);
	fl_set_object_lstyle(m_linear, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_physical, FL_BOLD_STYLE);
	fl_set_object_callback(m_linear, set_memory_physical, 0);
	fl_set_object_callback(m_physical, set_memory_physical, 1);
	fl_end_group();
	mem_physical = 0;

	fl_add_text(FL_NORMAL_TEXT,                             5, 35,  40, 25, "Units");
	m_size_text = fl_add_input(FL_NORMAL_INPUT,            40, 35,  70, 25, NULL);
	fl_set_input_maxchars(m_size_text, 8);
	fl_set_object_lstyle(m_size_text, FL_BOLD_STYLE);
	fl_set_input_return(m_size_text, FL_RETURN_END);
	fl_set_object_callback(m_size_text, show_memory, 0);
	fl_add_text(FL_NORMAL_TEXT,                         190,  38, 200,  25, "Press ENTER or click DUMP");

	dump_button = fl_add_button(FL_NORMAL_BUTTON,         135, 35,  40, 25, "Dump");
	fl_set_object_lstyle(dump_button, FL_BOLD_STYLE);
	fl_set_object_callback(dump_button, show_memory, 0);

	fl_bgn_group();
	fl_add_text(FL_NORMAL_TEXT,                       5,  69,  60,  25, "Unit Size");
	m_size_byte = fl_add_button(FL_RADIO_BUTTON,     65,  70,  20,  20, "B");
	m_size_word = fl_add_button(FL_RADIO_BUTTON,     85,  70,  20,  20, "W");
	m_size_dword = fl_add_button(FL_RADIO_BUTTON,   105,  70,  20,  20, "D");
	m_size_qword = fl_add_button(FL_RADIO_BUTTON,   125,  70,  20,  20, "Q");
	fl_set_button(m_size_dword, 1);
	fl_set_object_lstyle(m_size_byte, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_size_word, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_size_dword, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_size_qword, FL_BOLD_STYLE);
	fl_set_object_callback(m_size_byte, set_memory_size, 0);
	fl_set_object_callback(m_size_word, set_memory_size, 0);
	fl_set_object_callback(m_size_dword, set_memory_size, 0);
	fl_set_object_callback(m_size_qword, set_memory_size, 0);
	fl_add_text(FL_NORMAL_TEXT,                         190,  69, 200,  25, "Byte, Word, DoubleWord, or QuadWord");
	fl_end_group();
	mem_size = 'w';

	fl_bgn_group();
	fl_add_text(FL_NORMAL_TEXT,                     5,  99,  70,  25, "Unit Format");
	m_type_hex = fl_add_button(FL_RADIO_BUTTON,    75, 100,  20,  20, "H");
	m_type_dec = fl_add_button(FL_RADIO_BUTTON,    95, 100,  20,  20, "D");
	m_type_uns = fl_add_button(FL_RADIO_BUTTON,   115, 100,  20,  20, "U");
	m_type_oct = fl_add_button(FL_RADIO_BUTTON,   135, 100,  20,  20, "O");
	m_type_bin = fl_add_button(FL_RADIO_BUTTON,   155, 100,  20,  20, "B");
	fl_set_button(m_type_hex, 1);
	fl_set_object_lstyle(m_type_hex, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_type_dec, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_type_uns, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_type_oct, FL_BOLD_STYLE);
	fl_set_object_lstyle(m_type_bin, FL_BOLD_STYLE);
	fl_set_object_callback(m_type_hex, set_memory_type, 0);
	fl_set_object_callback(m_type_dec, set_memory_type, 0);
	fl_set_object_callback(m_type_uns, set_memory_type, 0);
	fl_set_object_callback(m_type_oct, set_memory_type, 0);
	fl_set_object_callback(m_type_bin, set_memory_type, 0);
	fl_add_text(FL_NORMAL_TEXT,                         190,  99, 250,  25, "Hex, Decimal, Unsigned Dec, Octal, or Binary");
	fl_end_group();
	mem_type = 'x';

	fl_end_form();



	//-----------------------------
	// config folder form
	//-----------------------------
	f_config_folder = fl_bgn_form(FL_FLAT_BOX, 510, 125);

        c_hislen_text = fl_add_input(FL_INT_INPUT,            5, 5,  50, 20, NULL);
        fl_set_input_maxchars(c_hislen_text, 4);
        fl_set_object_lstyle(c_hislen_text, FL_BOLD_STYLE);
        fl_set_input_return(c_hislen_text, FL_RETURN_END_CHANGED);
        fl_set_object_callback(c_hislen_text, set_config_hislen, 0);
	fl_add_text(FL_NORMAL_TEXT,                             60, 5,  200, 20, "Instruction History Length");

        c_sabove_text = fl_add_input(FL_INT_INPUT,            5, 30,  50, 20, NULL);
        fl_set_input_maxchars(c_sabove_text, 4);
        fl_set_object_lstyle(c_sabove_text, FL_BOLD_STYLE);
        fl_set_input_return(c_sabove_text, FL_RETURN_END_CHANGED);
        fl_set_object_callback(c_sabove_text, set_config_sabove, 0);
	fl_add_text(FL_NORMAL_TEXT,                             60, 30,  200, 20, "Stack values above ESP");

        c_sbelow_text = fl_add_input(FL_INT_INPUT,               5, 55,  50, 20, NULL);
        fl_set_input_maxchars(c_sbelow_text, 4);
        fl_set_object_lstyle(c_sbelow_text, FL_BOLD_STYLE);
        fl_set_input_return(c_sbelow_text, FL_RETURN_END_CHANGED);
        fl_set_object_callback(c_sbelow_text, set_config_sbelow, 0);
	fl_add_text(FL_NORMAL_TEXT,                             60, 55,  200, 20, "Stack values below ESP");

        c_steplock_text = fl_add_input(FL_INT_INPUT,             5, 80,  50, 20, NULL);
        fl_set_input_maxchars(c_steplock_text, 4);
        fl_set_object_lstyle(c_steplock_text, FL_BOLD_STYLE);
        fl_set_input_return(c_steplock_text, FL_RETURN_END_CHANGED);
        fl_set_object_callback(c_steplock_text, set_config_steplock, 0);
	fl_add_text(FL_NORMAL_TEXT,                             60, 80,  200, 20, "Step-Lock Time (seconds)");

        c_nextlock_text = fl_add_input(FL_INT_INPUT,             5, 105,  50, 20, NULL);
        fl_set_input_maxchars(c_nextlock_text, 4);
        fl_set_object_lstyle(c_nextlock_text, FL_BOLD_STYLE);
        fl_set_input_return(c_nextlock_text, FL_RETURN_END_CHANGED);
        fl_set_object_callback(c_nextlock_text, set_config_nextlock, 0);
	fl_add_text(FL_NORMAL_TEXT,                             60, 105,  200, 20, "Next-Lock Time (seconds)");


	trace_checkbox = fl_add_button(FL_PUSH_BUTTON,        205,   7,  15,  15, "");
	fl_set_object_lstyle(trace_checkbox, FL_BOLD_STYLE);
	fl_set_object_callback(trace_checkbox, toggle_tracing, 0);
	fl_add_text(FL_NORMAL_TEXT,                            230,   5,  250, 20, "Enable instruction tracing");

        clear_hislog_button = fl_add_button(FL_NORMAL_BUTTON,  205,   30,  90,  20, "Clear History");
        fl_set_object_lstyle(clear_hislog_button, FL_BOLD_STYLE);
        fl_set_object_callback(clear_hislog_button, clear_history, 0);


	fl_end_form();
