#include "updates.h"



void update_history( ){
	char temp_string[200], temp_string2[200];

	sprintf(temp_string, "@b0x%.8X\t0x%.4X:0x%.8X\t%s", i_physical_address, i_virtual_segment, i_virtual_offset, i_description);
	if(!strcmp(temp_string, history_lastline)){
		history_repeat++;
	} else {
		strcpy(history_lastline, temp_string);
		if(history_repeat){
			sprintf(temp_string2, "\t\t\t\t\t*** repeated %ld times", history_repeat);
			history_repeat = 0;
			fl_addto_browser(i_list, temp_string2);
			if(history_logfile != NULL) fprintf(history_logfile, "%s\n", temp_string2);
			if(history_length < fl_get_browser_maxline(i_list)) fl_delete_browser_line(i_list, 1);
		}
		fl_addto_browser(i_list, temp_string);
		fl_select_browser_line(i_list, fl_get_browser_maxline(i_list));
		if(history_logfile != NULL) fprintf(history_logfile, "%s\n", &temp_string[2]);
		if(history_length < fl_get_browser_maxline(i_list)) fl_delete_browser_line(i_list, 1);
	}
}


void update_memory( long tmp ){
	struct memwin_struct *m;
	char string[200], c, *s;

	if(bochs_offline) return;

	string[0]='@'; string[1]='b';
	s = &string[2];
	m = (struct memwin_struct *)tmp;

	fl_freeze_form(m->window);
	fl_clear_browser(m->list);

	if(m->physical == 1){
	  fprintf(writepipe, "xp /%d%c%c 0x%X\n", m->units, m->unit_size, m->unit_format, m->address);
	}else{
	  fprintf(writepipe, "x /%d%c%c 0x%X\n", m->units, m->unit_size, m->unit_format, m->address);
	}

	fgetc(readpipe);

	for(;;){
		c=fgetc(readpipe);
		if(c == '\n'){
			*s = '\0';
			fl_add_browser_line(m->list, string);
			s = &string[2];
		} else if(c == '<'){
			if(s == &string[2]){
				fscanf(readpipe, "bochs:%u>", &p_step);
				break;
			} else {
				fscanf(readpipe, "bogus");
			}
		} else if(c == '>'){
			fgetc(readpipe);
		} else if(c == EOF){
			break;
		} else if(c == ' ' || c == '\t'){
			if(s[-1] != '\t'){ *s = '\t'; s++; }
		} else {
			*s = c; s++;
		}
	}
	fl_unfreeze_form(m->window);
}
                
                        
void update_structure( int s ){
	char string[200], nr_string[10];
	int x, y, size, offset;
	unsigned val, val1;
	int start, total;

	if(bochs_offline) return;

	if(memlist[s].window == NULL) return;
	size = 0;
	fl_freeze_form(memlist[s].window);
	fl_clear_browser(memlist[s].table);

	start = atoi(fl_get_input(memlist[s].start_text));
	total = atoi(fl_get_input(memlist[s].total_text));

	if(total<0 || total>memlist[s].element_count){
		total=memlist[s].element_count;
		sprintf(nr_string, "%d", total);
		fl_set_input(memlist[s].total_text, nr_string);
	}
	if(start<0 || start>=memlist[s].element_count){
		start=0;
		fl_set_input(memlist[s].start_text, "0");
	}
	if(total+start>memlist[s].element_count){
		total=memlist[s].element_count-start;
		sprintf(nr_string, "%d", total);
		fl_set_input(memlist[s].total_text, nr_string);
	}

	for(y=0; y < memlist[s].value_count; y++) size += memlist[s].values[y].size;

	for(x=start; x < start+total; x++){
		offset = 0;
		sprintf(string, "@b0x%.8X (%d)", memlist[s].base+(x*size), x);
		fl_add_browser_line(memlist[s].table, string);
		for(y=0; y < memlist[s].value_count; y++){
		   if(memlist[s].values[y].name[0] == '\\' && memlist[s].values[y].name[1] == '\\'){
			string[0] = '\0';
			fl_add_browser_line(memlist[s].table, string);
		   } else {
			switch(memlist[s].values[y].size){
			case 1:
				fprintf(writepipe, "x /1bx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				sprintf(string, "@b\tBYTE  %s = 0x%.2X", memlist[s].values[y].name, val);
				break;
			case 2:
				fprintf(writepipe, "x /1hx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				sprintf(string, "@b\tWORD  %s = 0x%.4X", memlist[s].values[y].name, val);
				break;
			case 4:
				fprintf(writepipe, "x /1wx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				sprintf(string, "@b\tDWORD  %s = 0x%.8X", memlist[s].values[y].name, val);
				break;
			case 8:
				fprintf(writepipe, "x /2wx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X 0x%X", &val, &val1);
				sprintf(string, "@b\tQWORD  %s = 0x%.8X%.8X", memlist[s].values[y].name, val1, val);
				break;
			default:
				printf("WARNING: bfe encountered a structure value with a non power of 2 size, or a size larger than 8 bytes.\n");
			}

			prompt_read();
			offset += memlist[s].values[y].size;
			fl_add_browser_line(memlist[s].table, string);
		   }
		}
	}
	fl_unfreeze_form(memlist[s].window);
}


void update_xforms( ){
	char temp_string[50];

	if(bochs_offline) return;
#ifdef __DEBUG__
printf("UPDATE: prompt = %d\n", p_step); 
#endif
	instruction_read();
	fl_set_input(i_instruction_text, i_description);
	sprintf(temp_string, "0x%X:0x%X", i_virtual_segment, i_virtual_offset);
	fl_set_input(i_offset_text, temp_string);
	prompt_read();

	fprintf(writepipe, "dump_cpu\n");
	cpu_read();
	prompt_read();

	if(!get_physical((long)&cpu.cs, i_virtual_offset, &i_physical_address)) i_physical_address = 0;
	sprintf(temp_string, "0x%X", i_physical_address);
	fl_set_input(i_address_text, temp_string);

	update_history();

	// update registers
	if(update_state){

	sprintf(temp_string, "0x%X", cpu.eax);
	fl_set_input(r_eax_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.ebx);
	fl_set_input(r_ebx_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.ecx);
	fl_set_input(r_ecx_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.edx);
	fl_set_input(r_edx_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.ebp);
	fl_set_input(r_ebp_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.esi);
	fl_set_input(r_esi_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.edi);
	fl_set_input(r_edi_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.esp);
	fl_set_input(r_esp_text, temp_string);

	sprintf(temp_string, "0x%X", cpu.eflags);
	fl_set_input(r_eflags_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.eip);
	fl_set_input(r_eip_text, temp_string);

	sprintf(temp_string, "0x%X   %s", cpu.cs.segment, (cpu.cs.valid ? "valid" : "invalid"));
	fl_set_input(r_cs_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.ss.segment, (cpu.ss.valid ? "valid" : "invalid"));
	fl_set_input(r_ss_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.ds.segment, (cpu.ds.valid ? "valid" : "invalid"));
	fl_set_input(r_ds_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.es.segment, (cpu.es.valid ? "valid" : "invalid"));
	fl_set_input(r_es_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.fs.segment, (cpu.fs.valid ? "valid" : "invalid"));
	fl_set_input(r_fs_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.gs.segment, (cpu.gs.valid ? "valid" : "invalid"));
	fl_set_input(r_gs_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.ldtr.segment, (cpu.ldtr.valid ? "valid" : "invalid"));
	fl_set_input(r_ldtr_text, temp_string);
	sprintf(temp_string, "0x%X   %s", cpu.tr.segment, (cpu.tr.valid ? "valid" : "invalid"));
	fl_set_input(r_tr_text, temp_string);

	sprintf(temp_string, "B=0x%X  L=0x%X", cpu.gdtr.base, cpu.gdtr.limit);
	fl_set_input(r_gdtr_text, temp_string);
	sprintf(temp_string, "B=0x%X  L=0x%X", cpu.idtr.base, cpu.idtr.limit);
	fl_set_input(r_idtr_text, temp_string);

	sprintf(temp_string, "0x%X", cpu.dr0);
	fl_set_input(r_dr0_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.dr1);
	fl_set_input(r_dr1_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.dr2);
	fl_set_input(r_dr2_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.dr3);
	fl_set_input(r_dr3_text, temp_string);
//	sprintf(temp_string, "0x%X", cpu.dr4);
//	fl_set_input(r_dr4_text, temp_string);
//	sprintf(temp_string, "0x%X", cpu.dr5);
//	fl_set_input(r_dr5_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.dr6);
	fl_set_input(r_dr6_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.dr7);
	fl_set_input(r_dr7_text, temp_string);

	sprintf(temp_string, "0x%X", cpu.tr3);
	fl_set_input(r_tr3_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.tr4);
	fl_set_input(r_tr4_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.tr5);
	fl_set_input(r_tr5_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.tr6);
	fl_set_input(r_tr6_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.tr7);
	fl_set_input(r_tr7_text, temp_string);

	sprintf(temp_string, "0x%X", cpu.cr0);
	fl_set_input(r_cr0_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.cr1);
	fl_set_input(r_cr1_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.cr2);
	fl_set_input(r_cr2_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.cr3);
	fl_set_input(r_cr3_text, temp_string);
	sprintf(temp_string, "0x%X", cpu.cr4);
	fl_set_input(r_cr4_text, temp_string);

	fl_clear_browser(f_list);
	sprintf(temp_string, "@b%d\tCarry", cpu.eflags&1);
	fl_add_browser_line(f_list, temp_string);
	  sprintf(temp_string, "%d\t  -", (cpu.eflags&2)>>1);			// 1
	  fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tParity", (cpu.eflags&4)>>2);
	fl_add_browser_line(f_list, temp_string);
	  sprintf(temp_string, "%d\t  -", (cpu.eflags&8)>>3);			// 0
	  fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tAuxillary", (cpu.eflags&16)>>4);
	fl_add_browser_line(f_list, temp_string);
	  sprintf(temp_string, "%d\t  -", (cpu.eflags&32)>>5);			// 0
	  fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tZero", (cpu.eflags&64)>>6);
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tSign", (cpu.eflags&128)>>7);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tTrap", (cpu.eflags&256)>>8);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tInterrupt", (cpu.eflags&512)>>9);
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tDirection", (cpu.eflags&1024)>>10);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tOverflow", (cpu.eflags&2048)>>11);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tIOPL", (cpu.eflags&12288)>>12);
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tNested Task", (cpu.eflags&16384)>>14);     
	fl_add_browser_line(f_list, temp_string);
	  sprintf(temp_string, "%d\t  -", (cpu.eflags&32768)>>15);		// 0
	  fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tResume", (cpu.eflags&65536)>>16);
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tV86", (cpu.eflags&131072)>>17);
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tAlignment Check", (cpu.eflags&262144)>>18);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tVirtual Interrupt", (cpu.eflags&524288)>>19);     
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d        Virtual Interrupt Pending", (cpu.eflags&1048576)>>20);      
	fl_add_browser_line(f_list, temp_string);
	sprintf(temp_string, "@b%d\tID", (cpu.eflags&2097152)>>21);
	fl_add_browser_line(f_list, temp_string);

	update_stack();
	}
}


void update_stack( ){
	unsigned stack_value, stack_size, stack_bottom, stack_base;
	unsigned shift, ptr, tos_line;
	char temp_string[30];
	

	if(!cpu.ss.valid) return;

	tos_line = 0;

	fl_freeze_form(window);
	fl_clear_browser(s_list);

	if((cpu.cr0 & 1) && (cpu.ss.descriptor[1] & 0x400000)){		// check for a 32bit stack
		stack_size = 4;
		shift = 2;
		if(!get_physical((long)&cpu.ss, 0, &stack_base)){
			printf("ERROR: failed to calculate stack base, stack not updated.\n");
			return;
		}
	} else {
		stack_size = 2;
		shift = 1;
		stack_base = cpu.ss.segment<<4;
	}
	stack_bottom = (int)(cpu.esp-(stack_below<<shift)) > 0 ? (cpu.esp-(stack_below<<shift)) : 0;


	for(ptr=cpu.esp+(stack_above<<shift); ptr >= stack_bottom; ptr-=stack_size){
		if(stack_size == 2){
			fprintf(writepipe, "x /1hx 0x%X\n", stack_base+ptr);
		} else {
			fprintf(writepipe, "x /1wx 0x%X\n", stack_base+ptr);
		}
		if(fscanf(readpipe, "%*s %*s 0x%x", &stack_value) == 1){
			if(ptr == cpu.esp){
				sprintf(temp_string, "@bTOS\t0x%X", stack_value);
				tos_line = fl_get_browser_maxline(s_list) + 1;
			} else {
				sprintf(temp_string, "@b%+d\t0x%X", (int)(ptr-cpu.esp), stack_value);
			}
			if(((stack_size == 2) && !(ptr >= 0x10000)) || (stack_size == 4)){
				if(tos_line == (fl_get_browser_maxline(s_list) + 1)){
					fl_addto_browser(s_list, temp_string);
				} else fl_add_browser_line(s_list, temp_string);
			} else tos_line = 0;
		}
		prompt_read();
		if(ptr == 0) break;
	}
	if(tos_line) fl_select_browser_line(s_list, tos_line);
	fl_unfreeze_form(window);
}


void update_breakpoints( int redraw ){
	int x;
	char temp_string[30], temp2_string[30];

	if(bochs_offline) return;

	if(!restarting && !redraw){
		for(x=0; x<30; x++) breakpoints[x].enabled=0;
		fprintf(writepipe, "info break\n");
		breakpoints_read();
		prompt_read();
	}

	fl_freeze_form(window);
	fl_clear_browser(b_list);
	for(x=0; (x<30) && (breakpoints[x].enabled); x++){
		switch(breakpoints[x].type){
			case BREAKPOINT_VIRTUAL:	sprintf(temp_string, "@bVRT\t0x%X:0x%X", breakpoints[x].segment, breakpoints[x].offset);
							sprintf(temp2_string, "0x%X:0x%X", breakpoints[x].segment, breakpoints[x].offset);
							break;
			case BREAKPOINT_PHYSICAL:	sprintf(temp_string, "@bPHY\t0x%X", breakpoints[x].offset);
							sprintf(temp2_string, "0x%X", breakpoints[x].offset);
							break;
			case BREAKPOINT_LINEAR:		sprintf(temp_string, "@bLIN\t0x%X", breakpoints[x].offset);
							sprintf(temp2_string, "0x%X", breakpoints[x].offset);
							break;
		}
		fl_add_browser_line(b_list, temp_string);
		if(restarting){
			bp_type = breakpoints[x].type;
			fl_set_input(b_address_text, temp2_string);
			add_breakpoint(NULL, 0); 
		}
	}
	if(breakpoints[0].enabled && !redraw) fl_select_browser_line(b_list, 1);
	fl_unfreeze_form(window);
}
